#define KESC 27
#define ERROR "W+/R,W+/B,N,N"

	**************
FUNCTION RECLOCK(nWait,lTryAgain)
	**************
	/* Syntax: 	If RECLOCK(5)
								Replace Cust_Id With mCust_Id
							Else
								Return
							Endif

			First parameter is the number of seconds to wait before 
				failing the Function
	*/	 	

	LOCAL lForever

	nHoldWait := nWait
	lForever := (nWait == 0)
	DO WHILE .T.
		DO WHILE (lForever .or. nWait>0) .AND. LASTKEY()!=KESC
			IF RLOCK()
				RETURN(.T.)
				EXIT
			ENDIF
			INKEY(.5)
			nWait -= .5
		ENDDO
		IF lTryAgain
			IF RETRY()
				nWait := nHoldWait
				LOOP
			ELSE
				EXIT
			ENDIF
		ENDIF
	ENDDO
	RETURN(.F.)


	**************
FUNCTION FILLOCK(nWait,lTryAgain)
	**************
	// Syntax: 	If FILLOCK(5)
	//						Index on Cust_Id to Customer
	//					Else
	//						Return
	//					Endif
	//
	// First parameter is the number of seconds to wait before failing the Function

	LOCAL lForever
	nHoldWait := nWait
	lForever := (nWait == 0)
	DO WHILE .T.
		DO WHILE (lForever .or. nWait>0) .AND. LASTKEY()!=KESC
			IF FLOCK()
				RETURN(.T.)
				EXIT
			ENDIF
			INKEY(.5)
			nWait -= .5
		ENDDO
		IF lTryAgain
			IF RETRY()
				nWait := nHoldWait
				LOOP
			ELSE
				EXIT
			ENDIF
		ENDIF
	ENDDO
	RETURN(.F.)


	**************
FUNCTION RETRY
	**************
	/* 	Pop up screen to allow user to determine whether or not they would
			like to continue trying to obtain the lock, or go to the recovery
			routines.
	*/
	LOCAL cScreen1, nAction, cOldColor, tr, tc, br, bc, retval
	tr := 08
	tc := 10
	br := 12
	bc := 67
	cOldColor := SETCOLOR()
	cScreen1 := SAVESCREEN(tr,tc,br,bc)
	SETCOLOR(ERROR)
	@ tr,tc CLEAR TO br,bc
	@ tr,tc TO br,bc DOUBLE
	?? CHR(7)
	@tr+1,tc+3 SAY "Necessary record is currently in " +;
	"use unable to access"
	nAction:=2
	@ tr+3,28+4 Prompt "Retry"
	@ tr+3,38+4 Prompt "Quit"
	MENU TO nAction
	DO CASE
		CASE nAction == 1
			retval := .T.
		CASE nAction == 2 .OR. action == 0
			retval := .F.
	ENDCASE
	SETCOLOR(cOldColor)
	RESTSCREEN(tr,tc,br,bc,cScreen1)
	RETURN(retval)

	****************
Function NETUSE(cFile,lEx_use,nWait)
	****************
	/* Syntax: 	If NETUSE("Customer",.F.,5)
								Set Index to Customer
							Else
								Return
							Endif

			First parameter is the name of the database file to open					 		
			Second parameter is a logical value determining if the file is to be
			opened exclusive (.T.), or shared (.F.).
			Third parameter is the number of seconds to wait before failing
			the OpenDBF function.
	*/

	LOCAL lForever
	lForever := (nWait == 0)
	DO WHILE (lForever .OR. nWait > 0)
		If lEx_Use             
			USE (cFile) EXCLUSIVE	
		ELSE
			USE (cFile) SHARED
		ENDIF

		IF !NETERR()           		
			RETURN(.T.)
		ENDIF
		INKEY(.5)
		nWait -= .5
	ENDDO
	RETURN(.F.)		


	*************
FUNCTION ADDREC(nWait)
	*************
	// Syntax: 	If ADDREC(5)
	//						Replace ID With mID
	//					Else
	//						Return
	//					Endif
	//
	// First parameter is the number of seconds to wait before failing
	//	the function

	LOCAL lForever

	lForever := (nWait == 0)
	DO WHILE (lForever .OR. nWait > 0)
		APPEND BLANK
		IF !NETERR()
			RETURN(.T.)
		ENDIF
		INKEY(.5)		
		nWait -= .5
	ENDDO
	RETURN (.F.)
